
;*******************************************************************************
;SIRENE MULTISONS

;C/ PIC12F675

;AUTOR: CLAUDIO LARIOS

;DATA:14/07/2020

;Use MPLAB IDE V6.61 (assembly)

;Ateno ao tentar recompilar este arquivo: 
; Use a opo do compilador "disable case sensitivity'.
;Para isto v em Projects/Buid Options.../siren_m/ clique na caixa
; 'disable case sensitivity' / clique em 'ok'.

;USO DIDTICO
;ESTE ARQUIVO  PARTE INTEGRANTE DO BLOG LARIOS.TECNOLOGIA.WS
;*******************************************************************************/

;Program compiled by Great Cow BASIC (0.98.06 2019-06-12 (Windows 32 bit))
;Need help? See the GCBASIC forums at http://sourceforge.net/projects/gcbasic/forums,
;check the documentation or email w_cholmondeley at users dot sourceforge dot net.
;********************************************************************************

;Set up the assembler options (Chip type, clock source, other bits and pieces)
 LIST p=12F675, r=DEC
#include <P12F675.inc>
 __CONFIG _CP_OFF & _MCLRE_OFF & _WDT_OFF & _INTRC_OSC_NOCLKOUT
 errorlevel - 302
;********************************************************************************

;Set aside memory locations for variables
AUXA	EQU	33
AUXB	EQU	34
AUXC	EQU	35
AUXJ	EQU	36
CMCOM	EQU	45
CNT	EQU	48
DELAYTEMP	EQU	32
SAVEPCLATH	EQU	49
SYSBYTETEMPX	EQU	32
SYSLONGTEMPA	EQU	37
SYSLONGTEMPA_E	EQU	40
SYSLONGTEMPA_H	EQU	38
SYSLONGTEMPA_U	EQU	39
SYSLONGTEMPB	EQU	41
SYSLONGTEMPB_E	EQU	44
SYSLONGTEMPB_H	EQU	42
SYSLONGTEMPB_U	EQU	43
SYSSTATUS	EQU	47
SYSTEMP1	EQU	50
SYSTEMP1_E	EQU	53
SYSTEMP1_H	EQU	51
SYSTEMP1_U	EQU	52
SYSW	EQU	46
SYSWAITTEMPUS	EQU	37
SYSWAITTEMPUS_H	EQU	38
TIMER32	EQU	54
TIMER32_E	EQU	57
TIMER32_H	EQU	55
TIMER32_U	EQU	56
VEZ	EQU	58

;********************************************************************************

;Vectors
	ORG	0
	pagesel	BASPROGRAMSTART
	goto	BASPROGRAMSTART
	ORG	4
Interrupt

;********************************************************************************

;Save Context
	movwf	SysW
	swapf	STATUS,W
	movwf	SysSTATUS
	banksel	STATUS
;Store system variables
	movf	PCLATH,W
	movwf	SavePCLATH
	clrf	PCLATH
;On Interrupt handlers
	banksel	PIE1
	btfss	PIE1,TMR1IE
	goto	NotTMR1IF
	banksel	PIR1
	btfss	PIR1,TMR1IF
	goto	NotTMR1IF
	call	ISR_TIMER1
	bcf	PIR1,TMR1IF
	goto	INTERRUPTDONE
NotTMR1IF
;User Interrupt routine
INTERRUPTDONE
;Restore Context
;Restore system variables
	movf	SavePCLATH,W
	movwf	PCLATH
	swapf	SysSTATUS,W
	movwf	STATUS
	swapf	SysW,F
	swapf	SysW,W
	retfie
	banksel	STATUS

;********************************************************************************

;Start of program memory page 0
	ORG	33
BASPROGRAMSTART
;Call initialisation routines
	call	INITSYS
;Enable interrupts
	bsf	INTCON,GIE
	bsf	INTCON,PEIE

;Start of the main program
;*******************************************************************************
;SIRENE MULTISONS
;C/ PIC12F675
;AUTOR: CLAUDIO LARIOS
;DATA:14/07/2020
;Use Great Cow Basic Compiler
;USO DIDTICO
;ESTE ARQUIVO  PARTE INTEGRANTE DO BLOG LARIOS.TECNOLOGIA.WS
;*******************************************************************************/
;#define piezo     GPIO.5 'pino 2
;Dir     piezo     out
	banksel	TRISIO
	bcf	TRISIO,5
;#define j3     GPIO.4 'pino 3
;Dir     j3     in
	bsf	TRISIO,4
;#define j4     GPIO.3 'pino 4
;Dir     j4     in
	bsf	TRISIO,3
;#define j5     GPIO.2 'pino 5
;Dir     j5     in
	bsf	TRISIO,2
;#define j6     GPIO.1 'pino 6
;Dir     j6     in
	bsf	TRISIO,1
;#define j7     GPIO.0 'pino 7
;Dir     j7     in
	bsf	TRISIO,0
;variveis globais
;Dim cnt as byte
;Dim auxa as byte
;Dim auxb as byte
;Dim auxc as byte
;Dim auxd as byte
;Dim auxe as byte
;Dim auxj as byte
;Dim cnt as byte
;Dim vez as Byte
;Dim timer32 as long
;#define VALOR_DESLIGAMENTO 60000000 * (15)'entre parenteses = minutos
;*******************************************************************************
;SUBROTINAS
;*******************************************************************************/
;*******************************************************************************
;Rotina de Interrupo do Timer 1
;*******************************************************************************/
;On interrupt Timer1Overflow Call   ISR_TIMER1
	bsf	PIE1,TMR1IE
;*******************************************************************************
;ROTINA MAIN
;******************************************************************************/
;CMCOM = 7;//desliga comparadores
	movlw	7
	movwf	CMCOM
;GPIO = 0;//zera tudo
	banksel	GPIO
	clrf	GPIO
;TRISIO = 0b011111;//ajusta entradas e sadas
	movlw	31
	banksel	TRISIO
	movwf	TRISIO
;ANSEL = 0;// desabilita ports p/ conversores ADC
	clrf	ANSEL
;T1CON = 0x31;//liga timer1  prescaller/8
	movlw	49
	banksel	T1CON
	movwf	T1CON
;TMR1IF=0;
	bcf	PIR1,TMR1IF
;TMR1H=0X0B;
	movlw	11
	movwf	TMR1H
;TMR1L=0XDC;
	movlw	220
	movwf	TMR1L
;WPU= 0X3F;
	movlw	63
	banksel	WPU
	movwf	WPU
;OPTION_REG=0;
	clrf	OPTION_REG
;PIE1=1;//liga interrupo do timer 1
	movlw	1
	movwf	PIE1
;INTCON= 0B11000000;//GIE=1 /PEIE=1 //liga interrupo
	movlw	192
	movwf	INTCON
;*******************************************************************************
;LOOP PRINCIPAL DE REPETIO
;*******************************************************************************/
;do
SysDoLoop_S1
;vez = 0
	clrf	VEZ
;if(j3 = 0)then vez = vez + 1
	banksel	GPIO
	btfss	GPIO,4
	incf	VEZ,F
;if(j5 = 0)then vez = vez + 2
	btfsc	GPIO,2
	goto	ENDIF2
	movlw	2
	addwf	VEZ,F
ENDIF2
;if(j6 = 0)then vez = vez + 4
	btfsc	GPIO,1
	goto	ENDIF3
	movlw	4
	addwf	VEZ,F
ENDIF3
;if(j7 = 0)then vez = vez + 8
	btfsc	GPIO,0
	goto	ENDIF4
	movlw	8
	addwf	VEZ,F
ENDIF4
;select case vez
;case 1:
SysSelect1Case1
	decf	VEZ,W
	btfss	STATUS, Z
	goto	SysSelect1Case2
;som_sirene2
	call	SOM_SIRENE2
;case 2:
	goto	SysSelectEnd1
SysSelect1Case2
	movlw	2
	subwf	VEZ,W
	btfss	STATUS, Z
	goto	SysSelect1Case3
;som_sirene3
	call	SOM_SIRENE3
;case 3:
	goto	SysSelectEnd1
SysSelect1Case3
	movlw	3
	subwf	VEZ,W
	btfss	STATUS, Z
	goto	SysSelect1Case4
;som_sirene4
	call	SOM_SIRENE4
;case 4:
	goto	SysSelectEnd1
SysSelect1Case4
	movlw	4
	subwf	VEZ,W
	btfss	STATUS, Z
	goto	SysSelect1Case5
;som_sirene5
	call	SOM_SIRENE5
;case 5:
	goto	SysSelectEnd1
SysSelect1Case5
	movlw	5
	subwf	VEZ,W
	btfss	STATUS, Z
	goto	SysSelect1Case6
;som_sirene6
	call	SOM_SIRENE6
;case 6:
	goto	SysSelectEnd1
SysSelect1Case6
	movlw	6
	subwf	VEZ,W
	btfss	STATUS, Z
	goto	SysSelect1Case7
;som_sirene7
	call	SOM_SIRENE7
;case 7:
	goto	SysSelectEnd1
SysSelect1Case7
	movlw	7
	subwf	VEZ,W
	btfss	STATUS, Z
	goto	SysSelect1Case8
;som_sirene1
	call	SOM_SIRENE1
;case 8:
	goto	SysSelectEnd1
SysSelect1Case8
	movlw	8
	subwf	VEZ,W
	btfss	STATUS, Z
	goto	SysSelect1Case9
;som_sirene20
	call	SOM_SIRENE20
;case 9:
	goto	SysSelectEnd1
SysSelect1Case9
	movlw	9
	subwf	VEZ,W
	btfss	STATUS, Z
	goto	SysSelect1Case10
;som_sirene10
	call	SOM_SIRENE10
;case 10:
	goto	SysSelectEnd1
SysSelect1Case10
	movlw	10
	subwf	VEZ,W
	btfss	STATUS, Z
	goto	SysSelect1Case11
;som_sirene11
	call	SOM_SIRENE11
;case 11:
	goto	SysSelectEnd1
SysSelect1Case11
	movlw	11
	subwf	VEZ,W
	btfss	STATUS, Z
	goto	SysSelect1Case12
;som_sirene12
	call	SOM_SIRENE12
;case 12:
	goto	SysSelectEnd1
SysSelect1Case12
	movlw	12
	subwf	VEZ,W
	btfss	STATUS, Z
	goto	SysSelect1Case13
;som_sirene13
	call	SOM_SIRENE13
;case 13:
	goto	SysSelectEnd1
SysSelect1Case13
	movlw	13
	subwf	VEZ,W
	btfss	STATUS, Z
	goto	SysSelect1Case14
;som_sirene14
	call	SOM_SIRENE14
;case 14:
	goto	SysSelectEnd1
SysSelect1Case14
	movlw	14
	subwf	VEZ,W
	btfss	STATUS, Z
	goto	SysSelect1Case15
;som_sirene15
	call	SOM_SIRENE15
;case 15:
	goto	SysSelectEnd1
SysSelect1Case15
	movlw	15
	subwf	VEZ,W
	btfss	STATUS, Z
	goto	SysSelectEnd1
;som_sirene18
	call	SOM_SIRENE18
;End Select
SysSelectEnd1
;if(j4 = 0)then  'se jumper 4 colocado, conta tempo para desligar
	btfsc	GPIO,3
	goto	ENDIF5
;if(timer32 > VALOR_DESLIGAMENTO)then
	movf	TIMER32,W
	movwf	SysLONGTempB
	movf	TIMER32_H,W
	movwf	SysLONGTempB_H
	movf	TIMER32_U,W
	movwf	SysLONGTempB_U
	movf	TIMER32_E,W
	movwf	SysLONGTempB_E
	clrf	SysLONGTempA
	movlw	233
	movwf	SysLONGTempA_H
	movlw	164
	movwf	SysLONGTempA_U
	movlw	53
	movwf	SysLONGTempA_E
	call	SysCompLessThan32
	btfss	SysByteTempX,0
	goto	ENDIF6
;timer32 = 0
	clrf	TIMER32
	clrf	TIMER32_H
	clrf	TIMER32_U
	clrf	TIMER32_E
;SLEEP 'para de tocar e entra em modo 'sleep'
	sleep
;end if
ENDIF6
;end if
ENDIF5
;loop
	goto	SysDoLoop_S1
SysDoLoop_E1
;-----------------------fim do programa -------------------------------
BASPROGRAMEND
	sleep
	goto	BASPROGRAMEND

;********************************************************************************

INITSYS
;Resolve OSCCAL calibration
;GCB does not load saved calibration data into OSCCAL register on Baseline PIC. Therefore the FOSC is inaccurate when using internal RC oscillator.
;Solution:  Add following as the FIRST lines in the INITSYS sub in the System.h file
;This loads the saved calibration data from the last flash memory location at POR or any time the chip is reset.
;CALL 0x3ff
	call	1023
;movwf osccal
	banksel	OSCCAL
	movwf	OSCCAL
;Set up internal oscillator
;Handle OSCCON1 register for parts that have this register
;Ensure all ports are set for digital I/O and, turn off A/D
;SET ADFM OFF
	banksel	ADCON0
	bcf	ADCON0,ADFM
;Switch off A/D Var(ADCON0)
;SET ADCON0.ADON OFF
	bcf	ADCON0,ADON
;Commence clearing any ANSEL variants in the part
;ANSEL = 0
	banksel	ANSEL
	clrf	ANSEL
;End clearing any ANSEL variants in the part
;Turn off comparator - this is the default setting
;CMCON = 7
	movlw	7
	banksel	CMCON
	movwf	CMCON
;Turn off all ports
;GPIO = 0
	clrf	GPIO
	return

;********************************************************************************

INVERTE_SAIDA
;for auxa =1 to cnt
	clrf	AUXA
	movlw	1
	subwf	CNT,W
	btfss	STATUS, C
	goto	SysForLoopEnd33
SysForLoop33
	incf	AUXA,F
;wait 6 us
	movlw	2
	movwf	DELAYTEMP
DelayUS1
	decfsz	DELAYTEMP,F
	goto	DelayUS1
;next
	movf	CNT,W
	subwf	AUXA,W
	btfss	STATUS, C
	goto	SysForLoop33
SysForLoopEnd33
;piezo = piezo xor 1
	clrf	SysTemp1
	btfsc	GPIO,5
	incf	SysTemp1,F
	movlw	1
	xorwf	SysTemp1,F
	bcf	GPIO,5
	btfsc	SysTemp1,0
	bsf	GPIO,5
	return

;********************************************************************************

ISR_TIMER1
;timer32 = timer32 + 524288 'soma valor acumulado pelo timer 1 no overflow
	movlw	0
	addwf	TIMER32,F
	movlw	0
	btfsc	STATUS,C
	movlw	0 + 1
	addwf	TIMER32_H,F
	movlw	8
	btfsc	STATUS,C
	movlw	8 + 1
	addwf	TIMER32_U,F
	movlw	0
	btfsc	STATUS,C
	movlw	0 + 1
	addwf	TIMER32_E,F
;TMR1IF=0
	bcf	PIR1,TMR1IF
	return

;********************************************************************************

SOM_SIRENE1
;for auxd = 1 to 10  'numero de execues
;cnt=40;//frequencia
;for auxc = 0 to 50   'passo
	movlw	255
	movwf	AUXC
SysForLoop1
	incf	AUXC,F
;for auxb = 0 to 15   'permanncia
	movlw	255
	movwf	AUXB
SysForLoop2
	incf	AUXB,F
;inverte_saida
	call	INVERTE_SAIDA
;next
	movlw	15
	subwf	AUXB,W
	btfss	STATUS, C
	goto	SysForLoop2
SysForLoopEnd2
;if cnt > 128 then
	movf	CNT,W
	sublw	128
	btfsc	STATUS, C
	goto	ELSE8_1
;cnt = 0
	clrf	CNT
;else
	goto	ENDIF8
ELSE8_1
;cnt = cnt + 1
	incf	CNT,F
;end if
ENDIF8
;next
	movlw	50
	subwf	AUXC,W
	btfss	STATUS, C
	goto	SysForLoop1
SysForLoopEnd1
;next
	return

;********************************************************************************

SOM_SIRENE10
;gun space
;for auxd = 1 to 10  'numero de execues
;cnt = 39 'frequencia
	movlw	39
	movwf	CNT
;for auxc = 1 to 18   '/passo
	clrf	AUXC
SysForLoop15
	incf	AUXC,F
;for auxb = 1 to 9   'permanncia
	clrf	AUXB
SysForLoop16
	incf	AUXB,F
;inverte_saida
	call	INVERTE_SAIDA
;next
	movlw	9
	subwf	AUXB,W
	btfss	STATUS, C
	goto	SysForLoop16
SysForLoopEnd16
;cnt = cnt - 8
	movlw	8
	subwf	CNT,F
;next
	movlw	18
	subwf	AUXC,W
	btfss	STATUS, C
	goto	SysForLoop15
SysForLoopEnd15
;next
	return

;********************************************************************************

SOM_SIRENE11
;space gun 5 rpida  metralhando
;for auxd = 1 to 20   'numero de execues
;cnt = 10 'frequencia
	movlw	10
	movwf	CNT
;for auxc = 1 to 10  'passo
	clrf	AUXC
SysForLoop17
	incf	AUXC,F
;for auxb = 1 to 30   'permanncia
	clrf	AUXB
SysForLoop18
	incf	AUXB,F
;inverte_saida
	call	INVERTE_SAIDA
;next
	movlw	30
	subwf	AUXB,W
	btfss	STATUS, C
	goto	SysForLoop18
SysForLoopEnd18
;if cnt > 128 then
	movf	CNT,W
	sublw	128
	btfsc	STATUS, C
	goto	ELSE31_1
;cnt = cnt - 7
	movlw	7
	subwf	CNT,F
;else
	goto	ENDIF31
ELSE31_1
;cnt = cnt + 3
	movlw	3
	addwf	CNT,F
;end if
ENDIF31
;next
	movlw	10
	subwf	AUXC,W
	btfss	STATUS, C
	goto	SysForLoop17
SysForLoopEnd17
;next
	return

;********************************************************************************

SOM_SIRENE12
;space gun 4 rpida  metralhando
;for auxd = 1 to 20   'numero de execues
;cnt = 20 'frequencia
	movlw	20
	movwf	CNT
;for auxc = 1 to 30   'passo
	clrf	AUXC
SysForLoop19
	incf	AUXC,F
;for auxb = 1 to 6  'permanncia
	clrf	AUXB
SysForLoop20
	incf	AUXB,F
;inverte_saida
	call	INVERTE_SAIDA
;next
	movlw	6
	subwf	AUXB,W
	btfss	STATUS, C
	goto	SysForLoop20
SysForLoopEnd20
;if cnt > 128 then
	movf	CNT,W
	sublw	128
	btfsc	STATUS, C
	goto	ELSE34_1
;cnt = cnt - 2
	movlw	2
	subwf	CNT,F
;else
	goto	ENDIF34
ELSE34_1
;cnt = cnt + 4
	movlw	4
	addwf	CNT,F
;end if
ENDIF34
;next
	movlw	30
	subwf	AUXC,W
	btfss	STATUS, C
	goto	SysForLoop19
SysForLoopEnd19
;next
	return

;********************************************************************************

SOM_SIRENE13
;gun space2
;for auxd  = 1 to 10   'numero de execues
;cnt = 44 'frequencia
	movlw	44
	movwf	CNT
;for auxc = 1  to 18   'passo
	clrf	AUXC
SysForLoop21
	incf	AUXC,F
;for auxb = 1 to 9   'permanncia
	clrf	AUXB
SysForLoop22
	incf	AUXB,F
;inverte_saida
	call	INVERTE_SAIDA
;next
	movlw	9
	subwf	AUXB,W
	btfss	STATUS, C
	goto	SysForLoop22
SysForLoopEnd22
;cnt = cnt - 8
	movlw	8
	subwf	CNT,F
;next
	movlw	18
	subwf	AUXC,W
	btfss	STATUS, C
	goto	SysForLoop21
SysForLoopEnd21
;next
	return

;********************************************************************************

SOM_SIRENE14
;space gun 3  tchuuu! tchuuu!
;for auxd = 1 to 10  'numero de execues
;cnt = 20 'frequencia
	movlw	20
	movwf	CNT
;for auxc = 1 to 30   'passo
	clrf	AUXC
SysForLoop23
	incf	AUXC,F
;for auxb = 1 to 12   'permanncia
	clrf	AUXB
SysForLoop24
	incf	AUXB,F
;inverte_saida
	call	INVERTE_SAIDA
;next
	movlw	12
	subwf	AUXB,W
	btfss	STATUS, C
	goto	SysForLoop24
SysForLoopEnd24
;if cnt > 128 then
	movf	CNT,W
	sublw	128
	btfsc	STATUS, C
	goto	ELSE39_1
;cnt = cnt - 2
	movlw	2
	subwf	CNT,F
;else
	goto	ENDIF39
ELSE39_1
;cnt = cnt + 4
	movlw	4
	addwf	CNT,F
;end if
ENDIF39
;next
	movlw	30
	subwf	AUXC,W
	btfss	STATUS, C
	goto	SysForLoop23
SysForLoopEnd23
;next
	return

;********************************************************************************

SOM_SIRENE15
;extranha  doleto bum doleto bum
;for auxd = 1 to 10   'numero de execues
;cnt = 37'frequencia
	movlw	37
	movwf	CNT
;for auxc = 1  to 10   'passo
	clrf	AUXC
SysForLoop25
	incf	AUXC,F
;for auxb = 1  to 40   'permanncia
	clrf	AUXB
SysForLoop26
	incf	AUXB,F
;inverte_saida
	call	INVERTE_SAIDA
;next
	movlw	40
	subwf	AUXB,W
	btfss	STATUS, C
	goto	SysForLoop26
SysForLoopEnd26
;cnt = cnt - 20
	movlw	20
	subwf	CNT,F
;next
	movlw	10
	subwf	AUXC,W
	btfss	STATUS, C
	goto	SysForLoop25
SysForLoopEnd25
;next
	return

;********************************************************************************

SOM_SIRENE18
;sirene alarme rpido 1
;for auxd = 1  to 10   'numero de execues
;cnt = 40 'frequencia
	movlw	40
	movwf	CNT
;for auxc = 1 to 50   'passo
	clrf	AUXC
SysForLoop27
	incf	AUXC,F
;for auxb = 1 to 15  'permanncia
	clrf	AUXB
SysForLoop28
	incf	AUXB,F
;inverte_saida
	call	INVERTE_SAIDA
;next
	movlw	15
	subwf	AUXB,W
	btfss	STATUS, C
	goto	SysForLoop28
SysForLoopEnd28
;if cnt > 128 then
	movf	CNT,W
	sublw	128
	btfsc	STATUS, C
	goto	ELSE44_1
;cnt = cnt xor 0b10000000
	movlw	128
	xorwf	CNT,F
;else
	goto	ENDIF44
ELSE44_1
;cnt = cnt + 1
	incf	CNT,F
;end if
ENDIF44
;next
	movlw	50
	subwf	AUXC,W
	btfss	STATUS, C
	goto	SysForLoop27
SysForLoopEnd27
;next
	return

;********************************************************************************

SOM_SIRENE2
;for auxd = 1 to 100   'numero de execues
;cnt=40;//frequencia
;for auxc = 1 to 50   'passo
	clrf	AUXC
SysForLoop3
	incf	AUXC,F
;for auxb =1 to 3  'permanncia
	clrf	AUXB
SysForLoop4
	incf	AUXB,F
;inverte_saida
	call	INVERTE_SAIDA
;next
	movlw	3
	subwf	AUXB,W
	btfss	STATUS, C
	goto	SysForLoop4
SysForLoopEnd4
;if cnt > 64 then auxj = 1
	movf	CNT,W
	sublw	64
	btfsc	STATUS, C
	goto	ENDIF11
	movlw	1
	movwf	AUXJ
ENDIF11
;if cnt = 1 then auxj = 0
	decf	CNT,W
	btfsc	STATUS, Z
	clrf	AUXJ
;if auxj = 1 then
	decf	AUXJ,W
	btfss	STATUS, Z
	goto	ELSE13_1
;cnt = cnt - 1
	decf	CNT,F
;else
	goto	ENDIF13
ELSE13_1
;cnt = cnt + 1
	incf	CNT,F
;end if
ENDIF13
;next
	movlw	50
	subwf	AUXC,W
	btfss	STATUS, C
	goto	SysForLoop3
SysForLoopEnd3
;next
	return

;********************************************************************************

SOM_SIRENE20
;for auxd = 1  to 10   'numero de execues
;cnt = 73
	movlw	73
	movwf	CNT
;for auxc = 1 to 40   'passo
	clrf	AUXC
SysForLoop29
	incf	AUXC,F
;for auxb = 1 to 25   'permanncia
	clrf	AUXB
SysForLoop30
	incf	AUXB,F
;inverte_saida
	call	INVERTE_SAIDA
;next
	movlw	25
	subwf	AUXB,W
	btfss	STATUS, C
	goto	SysForLoop30
SysForLoopEnd30
;next
	movlw	40
	subwf	AUXC,W
	btfss	STATUS, C
	goto	SysForLoop29
SysForLoopEnd29
;cnt = 81
	movlw	81
	movwf	CNT
;for auxc = 1 to 40   'passo
	clrf	AUXC
SysForLoop31
	incf	AUXC,F
;for auxb = 1 to 25   'permanncia
	clrf	AUXB
SysForLoop32
	incf	AUXB,F
;inverte_saida
	call	INVERTE_SAIDA
;next
	movlw	25
	subwf	AUXB,W
	btfss	STATUS, C
	goto	SysForLoop32
SysForLoopEnd32
;next
	movlw	40
	subwf	AUXC,W
	btfss	STATUS, C
	goto	SysForLoop31
SysForLoopEnd31
;next
	return

;********************************************************************************

SOM_SIRENE3
;sirene legal  alerta
;for auxd =1 to 50   'numero de execues
;cnt = 100 'frequencia
	movlw	100
	movwf	CNT
;for auxc = 1 to 10   'passo
	clrf	AUXC
SysForLoop5
	incf	AUXC,F
;for auxb = 1  to 40   'permanncia
	clrf	AUXB
SysForLoop6
	incf	AUXB,F
;inverte_saida
	call	INVERTE_SAIDA
;next
	movlw	40
	subwf	AUXB,W
	btfss	STATUS, C
	goto	SysForLoop6
SysForLoopEnd6
;cnt = cnt - 2
	movlw	2
	subwf	CNT,F
;next
	movlw	10
	subwf	AUXC,W
	btfss	STATUS, C
	goto	SysForLoop5
SysForLoopEnd5
;next
	return

;********************************************************************************

SOM_SIRENE4
;sirene alarme rpido 1  toooouu! tooooouuu! toooouuu!
;for auxd = 1 to 30   'numero de execues
;cnt = 20 'frequencia
	movlw	20
	movwf	CNT
;for auxc = 1 to 30   'passo
	clrf	AUXC
SysForLoop7
	incf	AUXC,F
;for auxb = 1  to 12   'permanncia
	clrf	AUXB
SysForLoop8
	incf	AUXB,F
;inverte_saida
	call	INVERTE_SAIDA
;next
	movlw	12
	subwf	AUXB,W
	btfss	STATUS, C
	goto	SysForLoop8
SysForLoopEnd8
;if cnt > 128 then
	movf	CNT,W
	sublw	128
	btfsc	STATUS, C
	goto	ELSE18_1
;cnt = cnt - 2
	movlw	2
	subwf	CNT,F
;else
	goto	ENDIF18
ELSE18_1
;cnt = cnt + 2
	movlw	2
	addwf	CNT,F
;end if
ENDIF18
;next
	movlw	30
	subwf	AUXC,W
	btfss	STATUS, C
	goto	SysForLoop7
SysForLoopEnd7
;next
	return

;********************************************************************************

SOM_SIRENE5
;sirene  disparos rpidos  usar junto com outra
;for auxd = 1 to 50  'numero de execues
;cnt = 20' frequencia
	movlw	20
	movwf	CNT
;for  auxc = 1 to 10   'passo
	clrf	AUXC
SysForLoop9
	incf	AUXC,F
;for auxb = 1 to 12   'permanncia
	clrf	AUXB
SysForLoop10
	incf	AUXB,F
;inverte_saida
	call	INVERTE_SAIDA
;next
	movlw	12
	subwf	AUXB,W
	btfss	STATUS, C
	goto	SysForLoop10
SysForLoopEnd10
;if cnt > 128 then
	movf	CNT,W
	sublw	128
	btfsc	STATUS, C
	goto	ELSE21_1
;cnt = cnt - 5
	movlw	5
	subwf	CNT,F
;else
	goto	ENDIF21
ELSE21_1
;cnt = cnt + 5
	movlw	5
	addwf	CNT,F
;end if
ENDIF21
;next
	movlw	10
	subwf	AUXC,W
	btfss	STATUS, C
	goto	SysForLoop9
SysForLoopEnd9
;next
	return

;********************************************************************************

SOM_SIRENE6
;sirene  iaaauuuuu!  iiiaaauuu!
;for auxd = 1 to 10   'numero de execues
;cnt = 20 'frequencia
	movlw	20
	movwf	CNT
;for auxc = 1 to 10  ' passo
	clrf	AUXC
SysForLoop11
	incf	AUXC,F
;for auxb = 1 to 80   'permanncia
	clrf	AUXB
SysForLoop12
	incf	AUXB,F
;inverte_saida
	call	INVERTE_SAIDA
;next
	movlw	80
	subwf	AUXB,W
	btfss	STATUS, C
	goto	SysForLoop12
SysForLoopEnd12
;if cnt > 128  then
	movf	CNT,W
	sublw	128
	btfsc	STATUS, C
	goto	ELSE24_1
;cnt = cnt - 5
	movlw	5
	subwf	CNT,F
;else
	goto	ENDIF24
ELSE24_1
;cnt = cnt + 5
	movlw	5
	addwf	CNT,F
;end if
ENDIF24
;next
	movlw	10
	subwf	AUXC,W
	btfss	STATUS, C
	goto	SysForLoop11
SysForLoopEnd11
;next
	return

;********************************************************************************

SOM_SIRENE7
;for auxd = 1 to 30   'numero de execues
;cnt = 39 'frequencia
	movlw	39
	movwf	CNT
;for auxc = 1 to 12   'passo
	clrf	AUXC
SysForLoop13
	incf	AUXC,F
;for auxb = 1 to 6   'permanncia
	clrf	AUXB
SysForLoop14
	incf	AUXB,F
;inverte_saida
	call	INVERTE_SAIDA
;next
	movlw	6
	subwf	AUXB,W
	btfss	STATUS, C
	goto	SysForLoop14
SysForLoopEnd14
;cnt = cnt - 5
	movlw	5
	subwf	CNT,F
;next
	movlw	12
	subwf	AUXC,W
	btfss	STATUS, C
	goto	SysForLoop13
SysForLoopEnd13
;next
	return

;********************************************************************************

SYSCOMPLESSTHAN32
;dim SysLongTempA as long
;dim SysLongTempB as long
;dim SysByteTempX as byte
;clrf SysByteTempX
	clrf	SYSBYTETEMPX
;Test Exp, exit if more
;movf SysLongTempA_E,W
	movf	SYSLONGTEMPA_E,W
;subwf SysLongTempB_E,W
	subwf	SYSLONGTEMPB_E,W
;btfss STATUS,C
	btfss	STATUS,C
;return
	return
;If not more and not zero, is less
;btfss STATUS,Z
	btfss	STATUS,Z
;goto SCLT32True
	goto	SCLT32TRUE
;Test Upper, exit if more
;movf SysLongTempA_U,W
	movf	SYSLONGTEMPA_U,W
;subwf SysLongTempB_U,W
	subwf	SYSLONGTEMPB_U,W
;btfss STATUS,C
	btfss	STATUS,C
;return
	return
;If not more and not zero, is less
;btfss STATUS,Z
	btfss	STATUS,Z
;goto SCLT32True
	goto	SCLT32TRUE
;Test High, exit if more
;movf SysLongTempA_H,W
	movf	SYSLONGTEMPA_H,W
;subwf SysLongTempB_H,W
	subwf	SYSLONGTEMPB_H,W
;btfss STATUS,C
	btfss	STATUS,C
;return
	return
;If not more and not zero, is less
;btfss STATUS,Z
	btfss	STATUS,Z
;goto SCLT32True
	goto	SCLT32TRUE
;Test Low, exit if more or equal
;movf SysLongTempB,W
	movf	SYSLONGTEMPB,W
;subwf SysLongTempA,W
	subwf	SYSLONGTEMPA,W
;btfsc STATUS,C
	btfsc	STATUS,C
;return
	return
SCLT32TRUE
;comf SysByteTempX,F
	comf	SYSBYTETEMPX,F
	return

;********************************************************************************


 END
